//=====================================================================
// File Name : 2410slib.s
// Function  : S3C2410  (Assembly)
// Program   : Shin, On Pil (SOP)
// Date      : February 26, 2002
// Version   : 0.0
// History
//   0.0 : Programming start (February 26,2002) -> SOP
//   04.24.2002: purnnamu: optimized for NAND flash bootstrap 
//=====================================================================

//Interrupt, FIQ/IRQ disable
#define NOINT   0xc0    // 1100 0000  



//====================================
// MMU Cache/TLB/etc on/off functions
//====================================
#define R1_I		(1<<12)
#define R1_C		(1<<2)
#define R1_A		(1<<1)
#define R1_M    	(1)
#define R1_iA		(1<<31)
#define R1_nF   	(1<<30)

//void MMU_EnableICache(void)
   .global MMU_EnableICache
MMU_EnableICache:
	
   mrc p15,0,r0,c1,c0,0
   orr r0,r0,#R1_I
   mcr p15,0,r0,c1,c0,0
   mov pc,lr	


//void MMU_SetAsyncBusMode(void) 
// FCLK:HCLK= 1:2
   .global MMU_SetAsyncBusMode
MMU_SetAsyncBusMode:	
   mrc p15,0,r0,c1,c0,0
   mov r5,#0
   orr r5,r5,#R1_nF
   orr r5,r5,#R1_iA
   orr r0,r0,r5
   mcr p15,0,r0,c1,c0,0
   mov pc,lr	
